Index: /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.DataProcessor/DataProcessorView.cs
===================================================================
--- /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.DataProcessor/DataProcessorView.cs	(revision 8531)
+++ /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.DataProcessor/DataProcessorView.cs	(revision 8532)
@@ -386,7 +386,7 @@
           DataAnalysisProblemData problemData = null;
           if (saveFileDialog.FilterIndex == 1) {
-            problemData = new RegressionProblemData(dataset, dataset.VariableNames, dataset.VariableNames.First());
+            problemData = new RegressionProblemData(dataset, dataset.DoubleVariables, dataset.DoubleVariables.First());
           } else if (saveFileDialog.FilterIndex == 2) {
-            problemData = new ClassificationProblemData(dataset, dataset.VariableNames, dataset.VariableNames.First());
+            problemData = new ClassificationProblemData(dataset, dataset.DoubleVariables, dataset.DoubleVariables.First());
           } else {
             throw new ArgumentException("File extension doesn't exist");
@@ -401,7 +401,7 @@
     private Dataset ConvertDataset(DataSet dataSet) {
       ColumnGroup cg;
-      if (dataSet.ActiveColumnGroups.Count() > 0) {
+      if (dataSet.ActiveColumnGroups.Any()) {
         cg = dataSet.ActiveColumnGroups.First();
-      } else if (dataSet.ColumnGroups.Count() > 0) {
+      } else if (dataSet.ColumnGroups.Any()) {
         cg = dataSet.ColumnGroups.First();
       } else {
@@ -410,10 +410,10 @@
       List<IList> values = new List<IList>();
       foreach (var column in cg.Columns) {
-        if (column.DataType.Equals(typeof(double?))) {
-          values.Add(column.ValuesEnumerable.Cast<double?>().Select(x => x == null ? double.NaN : x).Cast<double>().ToList());
-        } else if (column.DataType.Equals(typeof(string))) {
-          values.Add(column.ValuesEnumerable.Cast<string>().ToList());
-        } else if (column.DataType.Equals(typeof(DateTime?))) {
-          values.Add(column.ValuesEnumerable.Cast<DateTime?>().Select(x => x == null ? new DateTime() : x).Cast<DateTime>().ToList());
+        if (column.DataType == typeof(double?)) {
+          values.Add(column.ValuesEnumerable.Cast<double?>().Select(x => x ?? double.NaN).ToList());
+        } else if (column.DataType == typeof(string)) {
+          values.Add(column.ValuesEnumerable.Cast<string>().Select(x => x ?? string.Empty).ToList());
+        } else if (column.DataType == typeof(DateTime?)) {
+          values.Add(column.ValuesEnumerable.Cast<DateTime?>().Select(x => x ?? default(DateTime)).ToList());
         } else {
           throw new ArgumentException("The variable values must be of type List<double>, List<string> or List<DateTime>");
Index: /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.DataProcessor/HeuristicLab.DataImporter.DataProcessor.csproj
===================================================================
--- /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.DataProcessor/HeuristicLab.DataImporter.DataProcessor.csproj	(revision 8531)
+++ /branches/HeuristicLab.DataImporter/HeuristicLab.DataImporter.DataProcessor/HeuristicLab.DataImporter.DataProcessor.csproj	(revision 8532)
@@ -94,11 +94,17 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Common.Resources-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Common.Resources-3.3.dll</HintPath>
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
-    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
     <Reference Include="HeuristicLab.Persistence-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Persistence-3.3.dll</HintPath>
@@ -109,5 +115,7 @@
       <Private>False</Private>
     </Reference>
-    <Reference Include="HeuristicLab.Problems.DataAnalysis-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Problems.DataAnalysis-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">